<?
define('TOP', dirname(dirname(dirname($_SERVER['SCRIPT_FILENAME']))) . '/avos/');
define('TEMPLATES', TOP . 'templates.admin/');

include(TOP . 'bin/bootstrap.php');

//
// see if we have POST data
//

$data = [
    'raw' => file_get_contents("php://input"),
    'site' => isset($_GET['site']) ? $_GET['site'] : '',
    'get' => serialize($_GET),
    'post' => is_array($_POST) ? serialize($_POST) : ''
];

if (!empty($data['raw'])) {
    foreach (json_decode($data['raw'], true) as $k => $v) {
        $data[$k] = $v;
    }
}

//
// if no POST data then use GET
//

else {
    $data = array_merge($data, $_GET);
    $data['raw'] = json_encode($data);
}

//
// first insert raw data in case of decode issues
//

#
# example chaturbate:
#
# $json = json_decode('{"track": "pornxtv", "commission": 99.88, "sid": "None", "type": "revshare_purchase", "text": "Revshare: 20% of Money Spent +  per broadcaster + 5% Referred Affiliate Income > Purchase", "id": "47ec97fe-9f2d-5e41-98f6-cfbcc6df4883", "user_uid": "NY83FAL", "checksum": "1d8ce49f26d71e95e748a92e4dc17df4", "attempt": 1, "tokens": 0}', true);
#
# example stripchat:
#
# https://avos.camzup.com/admin/postback.php?site=sc&user_uid={memberId}&track={campaignId}&source={sourceId}&commission={revenue}&device={device}&transactionId={transactionId}&transactionType={transactionType}
#
# {"raw":"","site":"sc","user_uid":"","track":"","source":"pussytuber","commission":"10","device":"mobile","transactionId":"117552769","transactionType":"purchase"}
#
# https://avos.camgirlstats.com/admin/postback.php?site=sc&user_uid=anon&track=&source=mysite&commission=99.99&device=mobile&transactionId=12345678&transactionType=purchase
#

//
// check for missing data
//

$data['track'] = isset($data['track']) ? $data['track'] : '';
$data['type'] = isset($data['type']) ? $data['type'] : '';
$data['commission'] = isset($data['commission']) ? $data['commission'] : 0;
$data['user_uid'] = isset($data['user_uid']) ? $data['user_uid'] : '';

switch ($data['site']) {
    case 'sc':
        echo "stripchat\n";
        $data['track'] = !empty($data['source']) ? $data['source'] : $data['track'];
        $data['type'] = !empty($data['transactionType']) ? $data['transactionType'] : $data['type'];
        break;
}

//
// log raw request
//

$id = \Avos\Database\query('INSERT INTO postbacks (site, raw, timestamp) VALUES (:site, :raw, unix_timestamp())', $data);

//
// update extra fields
//

if ($data && $id) {
    $data['id'] = $id;
    \Avos\Database\query('UPDATE postbacks SET track=:track, type=:type, amount=:commission, userid=:user_uid WHERE id=:id', $data);
}
