<? /*
$req = getRequests();
$tot = count($req);
$hrs = getConfig('site', 'logRequestsExpiry');
$cunts = [];
foreach ($req as $r) { $r[1] = \Avos\Utils\countryCode($r[1]); $r[1] == '' ? $cunts['Unknown']++ : (isset($cunts[$r[1]]) ? $cunts[$r[1]]++ : $cunts[$r[1]] = 1); }
arsort($cunts);
?> 
<h3><?= $tot ?> requests in the last <?= $hrs ?> hours</h3>
<p><?= implode(', ', array_map(function($k) use ($cunts, $tot) { return "$k " . (int)($cunts[$k] * 10000 / $tot)/100 . "%"; }, array_keys($cunts))); ?></p>
<!--<table>
<? $req = array_splice($req, 0, 1000); ?>
<? foreach ($req as $r): ?>
<tr>
<td><?= timeAgo($r[0]); ?></td>
<td><?= $r[1] ?></td>
<td><?= $r[2] ?></td>
<td><?= $r[3] ?></td>
<td><?= $r[4] ?></td>
<td><?= implode(', ', array_map(function($k) use ($r) { return "$k=" . $r[5][$k]; }, array_keys($r[5]))); ?></td>
</tr>
<? endforeach; */?>
<script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
<style>
    body {
        font-family: Arial, sans-serif;
        margin: 0;
        padding: 0;
        background-color: #f4f4f4;
        color: #333;
    }

    .chart-container {
        width: 80%;
        max-width: 400px;
        margin: 20px auto;
        padding: 20px;
        background-color: #fff;
        border-radius: 10px;
        box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
    }

    @media screen and (max-width: 768px) {
        .chart-container {
            width: 90%;
            max-width: 350px;
        }
    }

    .requests-container {
        display: grid;
        grid-template-columns: 1fr;
        gap: 20px;
        margin-top: 20px;
        padding: 0 20px;
    }

    .request-card {
        background-color: #fff;
        border-radius: 10px;
        box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
        padding: 15px;
        display: flex;
        flex-direction: column;
        gap: 10px;
    }

    .request-card h4 {
        font-size: 18px;
        margin: 0;
        color: #2c3e50;
    }

    .request-card p {
        font-size: 14px;
        color: #7f8c8d;
        margin: 0;
    }

    .table-container {
        width: 95%;
        margin: 20px auto;
        overflow-x: auto;
    }

    table {
        width: 100%;
        margin-top: 20px;
        border-collapse: collapse;
        background-color: #fff;
        border-radius: 10px;
        box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
    }

    table th, table td {
        padding: 12px;
        text-align: left;
        border: 1px solid #ddd;
    }

    table th {
        background-color: #2980b9;
        color: #fff;
        font-size: 14px;
    }

    table td {
        background-color: #ecf0f1;
        color: #2c3e50;
        font-size: 13px;
    }

    table tr:nth-child(even) td {
        background-color: #f4f6f7;
    }

    table tr:hover td {
        background-color: #bdc3c7;
    }

    .pagination {
        display: flex;
        justify-content: center;
        margin-top: 20px;
    }

    .pagination button {
        background-color: #2980b9;
        color: white;
        border: none;
        padding: 10px 15px;
        margin: 0 5px;
        cursor: pointer;
        font-size: 14px;
    }

    .pagination button:hover {
        background-color: #1d6b92;
    }

    .pagination button.disabled {
        background-color: #b0bec5;
        cursor: not-allowed;
    }

    /* Responsive table styling */
    @media (max-width: 768px) {
        table, th, td {
            display: block;
            width: 100%;
        }

        table th {
            text-align: center;
        }

        table td {
            text-align: left;
            padding-left: 10px;
            padding-right: 10px;
            padding-top: 5px;
        }

        table tr {
            display: block;
            margin-bottom: 10px;
        }

        table td:before {
            content: attr(data-label);
            font-weight: bold;
            width: 120px;
            display: inline-block;
        }
    }
</style>

<?php 
$req = getRequests();
$tot = count($req);
$hrs = getConfig('site', 'logRequestsExpiry');
$cunts = [];

// Count requests by country
foreach ($req as $r) { 
    $r[1] = \Avos\Utils\countryCode($r[1]); 
    $r[1] == '' ? $cunts['Unknown']++ : (isset($cunts[$r[1]]) ? $cunts[$r[1]]++ : $cunts[$r[1]] = 1); 
}
arsort($cunts);
?>

<h3><?= $tot ?> requests in the last <?= $hrs ?> hours</h3>
<p><?= implode(', ', array_map(function($k) use ($cunts, $tot) { return "$k " . (int)($cunts[$k] * 10000 / $tot)/100 . "%"; }, array_keys($cunts))); ?></p>

<!-- Pie Chart -->
<div class="chart-container">
    <canvas id="countryChart" width="200" height="200"></canvas>
</div>

<!-- Requests in Cards -->
<div class="table-container">
    <table id="requestsTable">
        <thead>
            <tr>
                <th>Time</th>
                <th>Country</th>
                <th>Request Type</th>
                <th>Details</th>
            </tr>
        </thead>
        <tbody>
            <?php $req = array_splice($req, 0, 1000); ?>
            <?php foreach ($req as $r): ?>
            <tr>
                <td><?= timeAgo($r[0]); ?></td>
                <td><?= $r[1] ?></td>
                <td><?= $r[2] ?></td>
                <td><?= implode(', ', array_map(function($k) use ($r) { return "$k=" . $r[5][$k]; }, array_keys($r[5]))); ?></td>
            </tr>
            <?php endforeach; ?>
        </tbody>
    </table>

    <div class="pagination">
        <button id="prevPage" class="disabled">Prev</button>
        <button id="nextPage">Next</button>
    </div>
</div>

<script>
// Pagination functionality
let currentPage = 1;
const rowsPerPage = 10; // Change this number based on how many rows you want to display per page
const rows = document.querySelectorAll('#requestsTable tbody tr');
const totalRows = rows.length;
const totalPages = Math.ceil(totalRows / rowsPerPage);

function showPage(page) {
    // Show only rows for the current page
    const startIndex = (page - 1) * rowsPerPage;
    const endIndex = page * rowsPerPage;

    rows.forEach((row, index) => {
        if (index >= startIndex && index < endIndex) {
            row.style.display = '';
        } else {
            row.style.display = 'none';
        }
    });

    // Update button states
    document.getElementById('prevPage').classList.toggle('disabled', page === 1);
    document.getElementById('nextPage').classList.toggle('disabled', page === totalPages);
}

document.getElementById('prevPage').addEventListener('click', () => {
    if (currentPage > 1) {
        currentPage--;
        showPage(currentPage);
    }
});

document.getElementById('nextPage').addEventListener('click', () => {
    if (currentPage < totalPages) {
        currentPage++;
        showPage(currentPage);
    }
});

// Initial page load
showPage(currentPage);

// Prepare the data for Chart.js
const chartData = <?php echo json_encode(array_map(function($country, $count) use ($tot) {
    return ['country' => $country, 'percentage' => ($count / $tot) * 100];
}, array_keys($cunts), $cunts)); ?>;

console.log(chartData); // Check the data output in console

if (chartData.length > 0) {
    const labels = chartData.map(item => item.country);
    const data = chartData.map(item => item.percentage);

    const ctx = document.getElementById('countryChart').getContext('2d');
    new Chart(ctx, {
        type: 'pie',
        data: {
            labels: labels,
            datasets: [{
                data: data,
                backgroundColor: ['#FF6384', '#36A2EB', '#FFCE56', '#4CAF50', '#FFC300', '#D1A1E0', '#FF5733'],
                hoverOffset: 4
            }]
        },
        options: {
            responsive: true,
            plugins: {
                legend: {
                    position: 'top',
                },
                tooltip: {
                    callbacks: {
                        label: function(tooltipItem) {
                            return tooltipItem.label + ': ' + tooltipItem.raw.toFixed(2) + '%';
                        }
                    }
                }
            }
        }
    });
} else {
    alert("No data to display in chart.");
}
</script>
